## ros-noetic-sdhlibrary-cpp 0.2.10

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(SDHLibrary-CPP)

## common source files
set(lib_sources
    "sdh/crc.cpp"
    "sdh/dsa.cpp"
    "sdh/rs232-cygwin.cpp"
    "sdh/sdhbase.cpp"
    "sdh/sdh_codes.cpp"
    "sdh/sdh.cpp"
    "sdh/sdhexception.cpp"
    "sdh/sdhserial.cpp"
    "sdh/serialbase.cpp"
    "sdh/simplestringlist.cpp"
    "sdh/simplevector.cpp"
    "sdh/tcpserial.cpp"
    "sdh/unit_converter.cpp"
    "sdh/util.cpp"
)

## common header files
set(lib_header
    "sdh/basisdef.h"
    "sdh/crc.h"
    "sdh/dbg.h"
    "sdh/dsa.h"
    "sdh/release.h"
    "sdh/rs232-cygwin.h"
    "sdh/sdhbase.h"
    "sdh/sdh_codes.h"
    "sdh/sdh_command_codes.h"
    "sdh/sdhexception.h"
    "sdh/sdh.h"
    "sdh/sdhlibrary_settings.h"
    "sdh/sdh_return_codes.h"
    "sdh/sdhserial.h"
    "sdh/serialbase.h"
    "sdh/simplestringlist.h"
    "sdh/simpletime.h"
    "sdh/simplevector.h"
    "sdh/tcpserial.h"
    "sdh/unit_converter.h"
    "sdh/util.h"
)

## add source and header files depending on operation system and CAN support

if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    add_definitions(-DOSNAME_LINUX=1)
elseif(${CMAKE_SYSTEM_NAME} STREQUAL "Cygwin")
    add_definitions(-DOSNAME_CYGWIN=1)
elseif(${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    list(APPEND lib_sources "sdh/rs232-vcc.cpp")
    list(APPEND lib_header "sdh/rs232-vcc.h")
endif()

option(WITH_ESD_CAN "ESD CAN support" OFF)
option(WITH_PEAK_CAN "PEAK CAN support" OFF)

if(WITH_ESD_CAN)
    find_package(libntcan REQUIRED)
    include_directories(${libntcan_INCLUDE_DIRS}/libntcan)
    link_libraries(${libntcan_LIBRARIES})
    add_definitions(-DWITH_ESD_CAN=1)
    list(APPEND lib_sources "sdh/canserial-esd.cpp")
    list(APPEND lib_header "sdh/canserial-esd.h")
else()
    add_definitions(-DWITH_ESD_CAN=0)
endif()

if(WITH_PEAK_CAN)
    find_package(libpcan REQUIRED)
    include_directories(${libpcan_INCLUDE_DIRS}/libpcan)
    link_libraries(${libpcan_LIBRARIES})
    add_definitions(-DWITH_PEAK_CAN=1)
    list(APPEND lib_sources "sdh/canserial-peak.cpp")
    list(APPEND lib_header "sdh/canserial-peak.h")
else()
    add_definitions(-DWITH_PEAK_CAN=0)
endif()

## define library
add_library(${PROJECT_NAME} SHARED ${lib_sources})

## install library
include(GNUInstallDirs)
set_target_properties(${PROJECT_NAME} PROPERTIES PUBLIC_HEADER "${lib_header}")
target_include_directories(${PROJECT_NAME} PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/sdh>"
    "$<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>")
install(TARGETS ${PROJECT_NAME} EXPORT sdhlibrary_cpp
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/schunk_sdh
)

install(EXPORT sdhlibrary_cpp
        DESTINATION share/sdhlibrary_cpp/cmake
        FILE sdhlibrary_cppConfig.cmake
)

option(BUILD_DEMOS "Build demo programs" OFF)

if(BUILD_DEMOS)
    ## demo source files
    set(demo_sources
        "demo/demo-benchmark.cpp"
        "demo/demo-dsa.cpp"
        "demo/demo-dsa-simple.cpp"
        "demo/demo-GetAxisActualAngle.cpp"
        "demo/demo-GetFingerXYZ.cpp"
        "demo/demo-griphand.cpp"
        "demo/demo-mimic.cpp"
        "demo/demo-radians.cpp"
        "demo/demo-simple2.cpp"
        "demo/demo-simple3.cpp"
        "demo/demo-simple.cpp"
        "demo/demo-simple-withtiming.cpp"
        "demo/demo-temperature.cpp"
        "demo/demo-velocity-acceleration.cpp"
    )

    ## demo executables
    include_directories(.)
    foreach(demo_source IN LISTS demo_sources)
        get_filename_component(demo_name ${demo_source} NAME_WE)
        add_executable(${demo_name} ${demo_source} "demo/sdhoptions.cpp")
        target_link_libraries(${demo_name} ${PROJECT_NAME})
        install(TARGETS ${demo_name} RUNTIME DESTINATION bin)
    endforeach()

    if(WITH_ESD_CAN OR WITH_PEAK_CAN)
        add_executable(cancat demo/cancat.cpp "demo/sdhoptions.cpp")
        target_link_libraries(cancat ${PROJECT_NAME})
        install(TARGETS cancat RUNTIME DESTINATION bin)
    endif()

    find_package(Boost COMPONENTS system thread)
    if(${Boost_FOUND})
        include_directories(${Boost_INCLUDE_DIRS})
        link_libraries(${Boost_LIBRARIES})
        add_executable(demo-contact-grasping demo/demo-contact-grasping.cpp demo/sdhoptions.cpp demo/dsaboost.cpp)
        target_link_libraries(demo-contact-grasping ${PROJECT_NAME})
        install(TARGETS demo-contact-grasping RUNTIME DESTINATION bin)
    endif()
endif()

=== Makefile ===
#=======================================================================
#//! \file
#//! \section sdhlibrary_cpp_makefile_general General file information
#//!   \author    Dirk Osswald 
#//!   \date      2007-01-03
#//!  
#//! \brief  
#//!   Makefile for SDH SDHLibrary C project.
#//!
#//!   This makefile can generate the C library itself, demo-programs and auxiliary stuff like
#//!   doxygen documentation or generate a distribution for delivery to end users.
#//!   
#//!   For a general description of the project see \ref sdhlibrary_cpp_dox_general "general project information".
#//!
#//! \section sdhlibrary_cpp_makefile_variables Makefile variables
#//!   The variables defined here state project specific settings which are
#//!   then used by the goals and/or by the included, more generic sub makefiles
#//!   like:
#//!   - \ref Makefile-common "Makefile-common"
#//!   - \ref Makefile-doc    "Makefile-doc"
#//!   - \ref Makefile-rules  "Makefile-rules"
#//! 
#//! \section sdhlibrary_cpp_makefile_targets Makefile targets
#//!   - \b \c all : generate everything
#//!     - \b \c build  : generate library and demo programs
#//!     - \b \c doc    : generate all documentation
#//!   - \b \c clean    : clean up generated program files, but not TAGS or doxygen doc
#//!   - \b \c mrproper : clean up all generated files, including TAGS and doxygen doc
#//!   - \b \c tags     : generate emacs TAGS file
#//!
#//! \section sdhlibrary_cpp_makefile_links Links
#//!   - The online documentation for \c gnu \c make can be found at
#//!     <a href="http://www.gnu.org/software/make/manual/make.html">
#//!     http://www.gnu.org/software/make/manual/make.html</a>
#//!  
#//! \section sdhlibrary_cpp_makefile_copyright Copyright
#//!
#//!  Copyright (c) 2007 SCHUNK GmbH & Co. KG
#//!
#//!  <HR>
#//!  \internal
#//!
#//!    \subsection sdhlibrary_cpp_makefile_details SVN related, detailed file specific information:
#//!      $LastChangedBy: Osswald2 $
#//!      $LastChangedDate: 2010-04-26 15:06:01 +0200 (Mo, 26 Apr 2010) $
#//!      \par SVN file revision:
#//!        $Id: Makefile 5547 2010-04-26 13:06:01Z Osswald2 $
#//!
#//!  \subsection sdhlibrary_cpp_makefile_changelog Changelog of this file:
#//!      \include Makefile.log
#//!
#=======================================================================
#//! \cond ignore_me   doxygen cannot parse Makefiles, so just ignore it

.DEFAULT_GOAL := all


BASEDIR = .

include ${BASEDIR}/Makefile-settings

## specify target specific definitions for TAGFILES:
#  (links to internal tag files make sense only for the internal docu,
#   for the external docu it would lead to broken links)
doc_internal_html: TAGFILES=../../../../tags/Protocol.tag=../../../../../../Protocol/doc/internal/html/ ../../../../tags/MotionControl.tag=../../../../../../MotionControl/doc/internal/html/ ../../../../tags/common.tag=../../../../../../common/doc/internal/html/
doc_internal: DOC_EXTRA_INPUT=
doc_internal: DOC_EXTRA_EXCLUDE=
doc_internal: DOC_EXTRA_EXCLUDE_PATTERNS=

doc_external_html: TAGFILES=
doc_external: DOC_EXTRA_EXCLUDE=demo/demo-ref.cpp demo/demo-test.cpp
doc_external: DOC_EXTRA_EXCLUDE_PATTERNS=

#
########################################################################



########################################################################
# now the goals

# list of sub directories with code (with the new Makefile.subdir this now does work on Linux)
SUBDIRS = sdh demo 


# Default goal: Make all (programs and documentation)
.PHONY: all
all: build 


# Build the library
.PHONY: build
build: TARGET=build
# cygwin gcc-4.3 is missing a newline after some messages which
# prevent eclipse from locating following messages. So use
# an output filter to correct this.
#build: export MAKE_OUTPUT_FILTER = 2>&1 | sed --unbuffered "s/This should work unless it involves constant data structures referencing symbols from auto-imported DLLs./This should work unless it involves constant data structures referencing symbols from auto-imported DLLs.\\\n/"
build: recursive

# Build the library only
.PHONY: build_lib
build_lib: TARGET=build_lib
build_lib: recursive

# Build the demo programs only
.PHONY: build_demo
build_demo: TARGET=build_demo
build_demo: recursive

# Build the test programs only
.PHONY: build_test
build_test: TARGET=build_test
build_test: recursive

tstinfo: TARGET=tstinfo
tstinfo: recursive

# Create and install generated files 
.PHONY: install
# let sub-makefiles install their part first:
install: TARGET=install
install: recursive 
#	# then install docu:
	@echo "installing documentation in ${INSTALL_DIR_DOC}"
	@if [ "${INSTALL_DIR_DOC}" != "" ]; then \
	  install -d ${INSTALL_DIR_DOC} ; \
	  cp -a ${DOCDIR}/*.html ${DOCDIR}/${SDHLIBRARY_NAME}-*.pdf ${DOCDIR}/external/ \
	    ${INSTALL_DIR_DOC} ; \
	  if [ -e "${DOCDIR}/internal/" ]; then \
	    cp -a ${DOCDIR}/internal/ \
	      ${INSTALL_DIR_DOC} ; \
	  fi ; \
	fi  

# uninstall previously installed files 
.PHONY: uninstall
# let sub-makefiles uninstall their part first:
uninstall: TARGET=uninstall
uninstall: recursive
#	# then uninstall docu:
	@echo "uninstalling documentation from ${INSTALL_DIR_DOC}"
	@if [ "${INSTALL_DIR_DOC}" != "" ]; then \
	  rm -rf ${INSTALL_DIR_DOC} ; \
	fi  


# Clean up generated files but not doc or tags.
.PHONY: clean
clean: TARGET=clean
clean: recursive


# Clean up generated files including doc and tags.
.PHONY: mrproper
mrproper: TARGET=mrproper
mrproper: clean doc_clean
mrproper: recursive

.PHONY: tidy
tidy: doc/index-overview.tidy doc/troubleshooting.tidy

######################################################################
#

# some common settings and targets are defined separately to keep this
# main Makefile more concise
include ${COMMON_DIR}/Makefile-common

# The variables and targets to generate documentation are defined
# separately to keep this main Makefile clearly laid out.
include ${COMMON_DIR}/Makefile-doc

# The variables and targets to call make recursively are defined
# separately to keep this main Makefile clearly laid out.
include ${COMMON_DIR}/Makefile-subdir

## For internal use only:
#  The variables and targets to generate a distribution are defined
#  separately to keep this main Makefile clearly laid out.
-include Makefile-dist

#
########################################################################

########################################################################
# additional rules for including the online help of the demo programs
# into the doxygen documentation

## the programs to extract the online help from
ONLINE_HELP_EXES = ${patsubst %.stackdump,,${wildcard ${BINDIR}/demo-*}}

## the dox files to generate
ONLINE_HELP_DOX = ${patsubst ${BINDIR}/demo-%,${DOCDIR}/onlinehelp-demo-%.dox,${ONLINE_HELP_EXES}}

## add dependencies to the doc_*_html targets
doc_external_html: ${ONLINE_HELP_DOX} 
doc_internal_html: ${ONLINE_HELP_DOX} 

## add extra dependency to the doc_clean target
doc_clean: doc_clean_onlinehelp

## pattern rule for generating the onlinehelp-*.dox file from the program
${DOCDIR}/onlinehelp-%.dox: ${BINDIR}/%
	@echo "Generating $@ from $<:"
	@echo -e "// auto generated file, do not edit!\n/*!\n  \\\file\n\n  \\\addtogroup sdh_library_cpp_onlinehelp_group\n  @{\n\n  \\\par Online help for program \\\c $*\n\n \\\code\n" > $@
	$< --help               >> $@
	@echo -e "\n\n\\\endcode\n  @} \n*/"   >> $@
	@echo -e "finished $@\n"

## rule to clean the generated onlinehelp-*.dox files
doc_clean_onlinehelp:
	rm -f ${ONLINE_HELP_DOX}
#
########################################################################


#-----------------------------------------------------------------------
# emacs settings:
# Local Variables:
# mode: Makefile
# End:
#-----------------------------------------------------------------------
#//! \endcond
########################################################################

=== debian/changelog ===
ros-noetic-sdhlibrary-cpp (0.2.10-1focal) focal; urgency=high

  * Create LICENSE
  * change license to Apache 2.0
  * export library
  * comment unused parameters
  * remove extra semicolon
  * fix arguments for formatted printing (-Wformat=)
  * demo executables
  * fix CAN handler casting
  * deactivate undefined 'NTCAN_ERROR_NO_BAUDRATE' and 'NTCAN_ERROR_LOM'
  * CMake support
  * remove deprecated dynamic exception specifications (-Wdeprecated)
  * fix ostream comparison
  * SDHLibrary-CPP 0.0.2.10
  * Contributors: Christian Rauch

 -- Christian Rauch <Christian.Rauch@ed.ac.uk>  Thu, 02 May 2019 23:00:00 -0000

=== debian/control ===
Source: ros-noetic-sdhlibrary-cpp
Section: misc
Priority: optional
Maintainer: Christian Rauch <Christian.Rauch@ed.ac.uk>
Build-Depends: debhelper (>= 9.0.0), cmake
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-sdhlibrary-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, 
Description: This is SDHLibrary-CPP, the C++ library to access an SDH (SCHUNK Dexterous Hand)

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-sdhlibrary-cpp//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
